Debian Bug report logs - #676874
[update-alternatives] Should allow too large priority values for backwards compatibility

version graph

Package: dpkg; Maintainer for dpkg is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg is src:dpkg.

Reported by: Aleksandar Micovic <metaleks@gmail.com>

Date: Sun, 10 Jun 2012 07:54:02 UTC

Severity: serious

Found in versions dpkg/1.16.4, ghc/7.4.1-3

Fixed in version dpkg/1.16.4.3

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, metaleks@gmail.com, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#676874; Package ghc. (Sun, 10 Jun 2012 07:54:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aleksandar Micovic <metaleks@gmail.com>:
New Bug report received and forwarded. Copy sent to metaleks@gmail.com, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 10 Jun 2012 07:54:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Aleksandar Micovic <metaleks@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 10 Jun 2012 03:46:55 -0400
Package: ghc
Version: 7.4.1-3
Severity: important

Dear Maintainer,

When I try to insall ghc, this is the output I get:

asm@tara:~$ sudo apt-get install ghc
Reading package lists... Done
Building dependency tree
Reading state information... Done
Suggested packages:
ghc-prof ghc-doc haskell-doc llvm-3.0
The following NEW packages will be installed:
ghc
0 upgraded, 1 newly installed, 0 to remove and 0 not upgraded.
Need to get 0 B/45.8 MB of archives.
After this operation, 288 MB of additional disk space will be used.
Selecting previously unselected package ghc.
(Reading database ... 166376 files and directories currently installed.)
Unpacking ghc (from .../archives/ghc_7.4.1-3_amd64.deb) ...
Processing triggers for man-db ...
Setting up ghc (7.4.1-3) ...
update-alternatives: priority is out of range

Usage: update-alternatives [<option> ...] <command>

Commands:
--install <link> <name> <path> <priority>
[--slave <link> <name> <path>] ...
add a group of alternatives to the system.
--remove <name> <path> remove <path> from the <name> group alternative.
--remove-all <name> remove <name> group from the alternatives system.
--auto <name> switch the master link <name> to automatic mode.
--display <name> display information about the <name> group.
--query <name> machine parseable version of --display <name>.
--list <name> display all targets of the <name> group.
--get-selections list master alternative names and their status.
--set-selections read alternative status from standard input.
--config <name> show alternatives for the <name> group and ask the
user to select which one to use.
--set <name> <path> set <path> as alternative for <name>.
--all call --config on all alternatives.

<link> is the symlink pointing to /etc/alternatives/<name>.
(e.g. /usr/bin/pager)
<name> is the master name for this link group.
(e.g. pager)
<path> is the location of one of the alternative target files.
(e.g. /usr/bin/less)
<priority> is an integer; options with higher numbers have higher priority in
automatic mode.

Options:
--altdir <directory> change the alternatives directory.
--admindir <directory> change the administrative directory.
--log <file> change the log file.
--force allow replacing files with alternative links.
--skip-auto skip prompt for alternatives correctly configured
in automatic mode (relevant for --config only)
--verbose verbose operation, more output.
--quiet quiet operation, minimal output.
--help show this help message.
--version show the version.
dpkg: error processing ghc (--configure):
subprocess installed post-installation script returned error exit status 2
Errors were encountered while processing:
ghc
E: Sub-process /usr/bin/dpkg returned an error code (1)

Running, dpkg --configure ghc, returns the same error. Someone on the Debian
IRC suggested that this was a packaging bug that just fudged the priority
number for update-alternatives. I have reproduced this bug on two independent
systems now.



-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-2-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_GB.utf8, LC_CTYPE=en_GB.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages ghc depends on:
ii  gcc          4:4.7.0-6
ii  libbsd-dev   0.4.0-1
ii  libc6        2.13-33
ii  libc6-dev    2.13-33
ii  libffi-dev   3.0.10-3
ii  libffi5      3.0.10-3
ii  libgmp-dev   2:5.0.5+dfsg-2
ii  libgmp10     2:5.0.5+dfsg-2
ii  libncurses5  5.9-8
ii  libtinfo5    5.9-8

ghc recommends no packages.

Versions of packages ghc suggests:
pn  ghc-doc      <none>
pn  ghc-prof     <none>
pn  haskell-doc  <none>
pn  llvm-3.0     <none>
ii  perl         5.14.2-11

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#676874; Package ghc. (Sun, 10 Jun 2012 19:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 10 Jun 2012 19:15:06 GMT) Full text and rfc822 format available.

Message #10 received at 676874@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Aleksandar Micovic <metaleks@gmail.com>, 676874@bugs.debian.org
Cc: 580038@bugs.debian.org
Subject: Re: [Pkg-haskell-maintainers] Bug#676874: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 10 Jun 2012 21:11:04 +0200
[Message part 1 (text/plain, inline)]
Hi,

Am Sonntag, den 10.06.2012, 03:46 -0400 schrieb Aleksandar Micovic:
> update-alternatives: priority is out of range

this is likely due to a call setting the priority to 8600000600, which
has been there since ghc6_6.4-1 (13 Mar 2005!). Was there a recent
change in update-alternatives that disallows large priorities? Sounds
like this change in dpkg_1.16.4:
  * Check all parsed integers for out of range errors; i.e. that no negative
    values are allowed if not appropriate, and that no overflows occur.
    Closes: #580038
And indeed, the diff at
http://anonscm.debian.org/gitweb/?p=dpkg/dpkg.git;a=commitdiff;h=2bf4b48#patch12 confirms that. CC’ing 580038@b.d.o for that; looks like the fix introduced a regression.

(Not saying it is sane to use that number, but its there and its been
there for long, so I don’t think dpkg should break that so shortly
before the freeze.)

Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#676874; Package ghc. (Sun, 10 Jun 2012 19:48:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 10 Jun 2012 19:48:08 GMT) Full text and rfc822 format available.

Message #15 received at 676874@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Joachim Breitner <nomeata@debian.org>, 580038@bugs.debian.org
Cc: Aleksandar Micovic <metaleks@gmail.com>, 676874@bugs.debian.org
Subject: Re: Bug#580038: [Pkg-haskell-maintainers] Bug#676874: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 10 Jun 2012 21:44:37 +0200
On Sun, 2012-06-10 at 21:11:04 +0200, Joachim Breitner wrote:
> Am Sonntag, den 10.06.2012, 03:46 -0400 schrieb Aleksandar Micovic:
> > update-alternatives: priority is out of range
> 
> this is likely due to a call setting the priority to 8600000600, which
> has been there since ghc6_6.4-1 (13 Mar 2005!). Was there a recent
> change in update-alternatives that disallows large priorities? Sounds
> like this change in dpkg_1.16.4:
>   * Check all parsed integers for out of range errors; i.e. that no negative
>     values are allowed if not appropriate, and that no overflows occur.
>     Closes: #580038
> And indeed, the diff at
> http://anonscm.debian.org/gitweb/?p=dpkg/dpkg.git;a=commitdiff;h=2bf4b48#patch12
> confirms that. CC’ing 580038@b.d.o for that; looks like the fix introduced
> a regression.

Well that number is bigger than INT_MAX which means it cannot be
stored in the priority field used by u-a, as such that number will
wrap-around and will not be what it's meant to be. This silent
truncation has happened up to now, but it's catched correctly from
now on.

> (Not saying it is sane to use that number, but its there and its been
> there for long, so I don’t think dpkg should break that so shortly
> before the freeze.)

The above has happened probably since the rewrite of u-a from perl to
C in 1.15.0, which is already included in squeeze.

regards,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#676874; Package ghc. (Sun, 10 Jun 2012 19:54:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 10 Jun 2012 19:54:04 GMT) Full text and rfc822 format available.

Message #20 received at 676874@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Guillem Jover <guillem@debian.org>
Cc: 580038@bugs.debian.org, Aleksandar Micovic <metaleks@gmail.com>, 676874@bugs.debian.org
Subject: Re: Bug#580038, #676874: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 10 Jun 2012 21:51:39 +0200
[Message part 1 (text/plain, inline)]
Hi,

Am Sonntag, den 10.06.2012, 21:44 +0200 schrieb Guillem Jover:
> On Sun, 2012-06-10 at 21:11:04 +0200, Joachim Breitner wrote:
> > Am Sonntag, den 10.06.2012, 03:46 -0400 schrieb Aleksandar Micovic:
> > > update-alternatives: priority is out of range
> > 
> > this is likely due to a call setting the priority to 8600000600, which
> > has been there since ghc6_6.4-1 (13 Mar 2005!). Was there a recent
> > change in update-alternatives that disallows large priorities? Sounds
> > like this change in dpkg_1.16.4:
> >   * Check all parsed integers for out of range errors; i.e. that no negative
> >     values are allowed if not appropriate, and that no overflows occur.
> >     Closes: #580038
> > And indeed, the diff at
> > http://anonscm.debian.org/gitweb/?p=dpkg/dpkg.git;a=commitdiff;h=2bf4b48#patch12
> > confirms that. CC’ing 580038@b.d.o for that; looks like the fix introduced
> > a regression.
> 
> Well that number is bigger than INT_MAX which means it cannot be
> stored in the priority field used by u-a, as such that number will
> wrap-around and will not be what it's meant to be. This silent
> truncation has happened up to now, but it's catched correctly from
> now on.

could you, just to not break existing packages, change the code to only
print a warning and set the value to INT_MAX? After all the dpkg from
wheezy should be able to install packages in squeeze, shoudn’t it?

We’ll change the number in ghc, or rather replace the alternative by a
regular file, but I’d like to not do such changes so short before the
release.

> > (Not saying it is sane to use that number, but its there and its been
> > there for long, so I don’t think dpkg should break that so shortly
> > before the freeze.)
> 
> The above has happened probably since the rewrite of u-a from perl to
> C in 1.15.0, which is already included in squeeze.

I guess by „the above“ you mean the wrap-around, which theoretically
lead to wrong results, but in this is harmless as since squeeze (or even
longer) only ghc was providing an alternative for runhaskell. The
explicit check in 1.16.4, though, broke the existing packages in
practice.

I’m sorry for having to ask for the work-around outlined above, but I
don do think its the right course of action.

Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#676874; Package ghc. (Sun, 10 Jun 2012 20:06:18 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 10 Jun 2012 20:06:18 GMT) Full text and rfc822 format available.

Message #25 received at 676874@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Joachim Breitner <nomeata@debian.org>
Cc: 580038@bugs.debian.org, Aleksandar Micovic <metaleks@gmail.com>, 676874@bugs.debian.org
Subject: Re: Bug#580038, #676874: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 10 Jun 2012 22:05:34 +0200
On Sun, 2012-06-10 at 21:51:39 +0200, Joachim Breitner wrote:
> Am Sonntag, den 10.06.2012, 21:44 +0200 schrieb Guillem Jover:
> > Well that number is bigger than INT_MAX which means it cannot be
> > stored in the priority field used by u-a, as such that number will
> > wrap-around and will not be what it's meant to be. This silent
> > truncation has happened up to now, but it's catched correctly from
> > now on.
> 
> could you, just to not break existing packages, change the code to only
> print a warning and set the value to INT_MAX? After all the dpkg from
> wheezy should be able to install packages in squeeze, shoudn’t it?

Yeah, I guess that can be done, will prepare 1.16.4.3 with this.

> We’ll change the number in ghc, or rather replace the alternative by a
> regular file, but I’d like to not do such changes so short before the
> release.

OTOH I honestly don't see the danger in lowering the priority, even at
this point in time.

> > > (Not saying it is sane to use that number, but its there and its been
> > > there for long, so I don’t think dpkg should break that so shortly
> > > before the freeze.)
> > 
> > The above has happened probably since the rewrite of u-a from perl to
> > C in 1.15.0, which is already included in squeeze.
> 
> I guess by „the above“ you mean the wrap-around, which theoretically
> lead to wrong results, but in this is harmless as since squeeze (or even
> longer) only ghc was providing an alternative for runhaskell. The
> explicit check in 1.16.4, though, broke the existing packages in
> practice.

If it's only being used by one package then sure that's fine, otherwise
it might have produced undesirable effects if other packages used a
smaller priorirty but bigger after this wrapped-around.

> I’m sorry for having to ask for the work-around outlined above, but I
> don do think its the right course of action.

No problem, I'll just mark the workaround to be removed after wheezy.

thanks,
guillem




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#676874; Package ghc. (Sun, 10 Jun 2012 20:39:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 10 Jun 2012 20:39:16 GMT) Full text and rfc822 format available.

Message #30 received at 676874@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Guillem Jover <guillem@debian.org>, 676874@bugs.debian.org
Cc: Aleksandar Micovic <metaleks@gmail.com>, 580038@bugs.debian.org
Subject: Re: [Pkg-haskell-maintainers] Bug#676874: Bug#580038, #676874: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 10 Jun 2012 22:35:59 +0200
[Message part 1 (text/plain, inline)]
Hi,

Am Sonntag, den 10.06.2012, 22:05 +0200 schrieb Guillem Jover:
> > could you, just to not break existing packages, change the code to only
> > print a warning and set the value to INT_MAX? After all the dpkg from
> > wheezy should be able to install packages in squeeze, shoudn’t it?
> 
> Yeah, I guess that can be done, will prepare 1.16.4.3 with this.

Thanks! I’ll reassign the bug to dpkg so that you have something to
close :-)

> > We’ll change the number in ghc, or rather replace the alternative by a
> > regular file, but I’d like to not do such changes so short before the
> > release.
> 
> OTOH I honestly don't see the danger in lowering the priority, even at
> this point in time.

I am always a bit worried about the ABI hashes in haskell packages
changing unexpectedly, requiring rebuilds of many haskell libraries. I
don’t _expect_ that to happen, but I’d rather not risk it in the middle
of the transition. Plus there are the old packages that should, IMHO,
not fail with dpkg.

Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Bug reassigned from package 'ghc' to 'dpkg'. Request was from Joachim Breitner <nomeata@debian.org> to control@bugs.debian.org. (Sun, 10 Jun 2012 20:39:20 GMT) Full text and rfc822 format available.

No longer marked as found in versions ghc/7.4.1-3. Request was from Joachim Breitner <nomeata@debian.org> to control@bugs.debian.org. (Sun, 10 Jun 2012 20:39:21 GMT) Full text and rfc822 format available.

Changed Bug title to '[update-alternatives] Should allow too large priority values for backwards compatibility' from 'ghc fails to configure after install (update-alternatives priority out of range)' Request was from Joachim Breitner <nomeata@debian.org> to control@bugs.debian.org. (Sun, 10 Jun 2012 20:39:21 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Sun, 10 Jun 2012 20:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 10 Jun 2012 20:51:05 GMT) Full text and rfc822 format available.

Message #41 received at 676874@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Joachim Breitner <nomeata@debian.org>
Cc: Guillem Jover <guillem@debian.org>, 676874@bugs.debian.org, Aleksandar Micovic <metaleks@gmail.com>
Subject: Re: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 10 Jun 2012 15:48:27 -0500
clone 676874 -1
found 676874 dpkg/1.16.4
reassign -1 ghc 7.4.1-3
found -1 ghc6/6.4-1
retitle -1 ghc: update-alternatives priority out of range
quit

Joachim Breitner wrote:
> Am Sonntag, den 10.06.2012, 22:05 +0200 schrieb Guillem Jover:

>> OTOH I honestly don't see the danger in lowering the priority, even at
>> this point in time.
>
> I am always a bit worried about the ABI hashes in haskell packages
> changing unexpectedly, requiring rebuilds of many haskell libraries. I
> don’t _expect_ that to happen, but I’d rather not risk it in the middle
> of the transition. Plus there are the old packages that should, IMHO,
> not fail with dpkg.

Cloning and assigning to ghc.  If the way ABI is tracked in ghc is
causing valid bugs to be thrown away, that's a problem, in my opinion.

I would like to see this fixed in ghc/wheezy so the workaround can be
safely dropped in dpkg/wheezy+1.  No rush, though (i.e., it can happen
after the transition if there's no upload until then).

Thanks and hope that helps,
Jonathan




Bug 676874 cloned as bug 676970 Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Sun, 10 Jun 2012 20:51:06 GMT) Full text and rfc822 format available.

Marked as found in versions dpkg/1.16.4. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Sun, 10 Jun 2012 20:51:07 GMT) Full text and rfc822 format available.

Added indication that 676874 affects ghc Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Mon, 11 Jun 2012 13:27:07 GMT) Full text and rfc822 format available.

Marked as found in versions ghc/7.4.1-3. Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Mon, 11 Jun 2012 13:27:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Thu, 14 Jun 2012 09:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Cyril Brulebois <kibi@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 14 Jun 2012 09:09:03 GMT) Full text and rfc822 format available.

Message #54 received at 676874@bugs.debian.org (full text, mbox):

From: Cyril Brulebois <kibi@debian.org>
To: Jonathan Nieder <jrnieder@gmail.com>, 676874@bugs.debian.org
Cc: Joachim Breitner <nomeata@debian.org>, Aleksandar Micovic <metaleks@gmail.com>
Subject: Re: Bug#676874: ghc fails to configure after install (update-alternatives priority out of range)
Date: Thu, 14 Jun 2012 11:04:41 +0200
[Message part 1 (text/plain, inline)]
severity 676970 serious
thanks

Jonathan Nieder <jrnieder@gmail.com> (10/06/2012):
> Cloning and assigning to ghc.  If the way ABI is tracked in ghc is
> causing valid bugs to be thrown away, that's a problem, in my opinion.

Indeed. And since the package isn't installable right now, bumping
severity to serious.

Mraw,
KiBi.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Thu, 14 Jun 2012 09:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 14 Jun 2012 09:24:08 GMT) Full text and rfc822 format available.

Message #59 received at 676874@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Cyril Brulebois <kibi@debian.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 676874@bugs.debian.org, 676970@bugs.debian.org
Subject: Re: Bug#676874: ghc fails to configure after install (update-alternatives priority out of range)
Date: Thu, 14 Jun 2012 11:20:05 +0200
[Message part 1 (text/plain, inline)]
Dear Cyril,

Am Donnerstag, den 14.06.2012, 11:04 +0200 schrieb Cyril Brulebois:
> severity 676970 serious
> thanks
> 
> Jonathan Nieder <jrnieder@gmail.com> (10/06/2012):
> > Cloning and assigning to ghc.  If the way ABI is tracked in ghc is
> > causing valid bugs to be thrown away, that's a problem, in my opinion.
> 
> Indeed. And since the package isn't installable right now, bumping
> severity to serious.

I’m really not sure what this is about. Who is throwing bugs away (and
what does that mean anyways to throw a bug away?)? All I am saying is
that at this point of the release cycle, I am very reluctant to do an
upload of GHC. I’m sure those of the release team who currently manage
the transition will agree that it would be unwise now. I am not saying
that I won’t fix GHC (or rather, adjust GHC to changed semantics in
dpkg) at all; quite contrary I did announce that I’ll do it on the next
upload.

It there a deeper misunderstanding here?

An in case this bug now hinders the migration that mehdi set up for
today: I think this bug can be ignored for wheezy right now, as the dpkg
version in wheezy does _not_ make ghc fail to install. We just should
make sure that before dpkg 1.16.4 it is turned the error into a warning,
e.g. 676874 is closed. (Doesn’t this make 676874 RC?) That fix is
required anyways as wheezy’s dpkg needs to be able to install packages
from squeeze.

Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Thu, 14 Jun 2012 11:30:44 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 14 Jun 2012 11:30:49 GMT) Full text and rfc822 format available.

Message #64 received at 676874@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Joachim Breitner <nomeata@debian.org>
Cc: Cyril Brulebois <kibi@debian.org>, 676874@bugs.debian.org, 676970@bugs.debian.org
Subject: Re: ghc fails to configure after install (update-alternatives priority out of range)
Date: Thu, 14 Jun 2012 06:29:54 -0500
Joachim Breitner wrote:

> An in case this bug now hinders the migration that mehdi set up for
> today:

The severity does seem inflated.  Luckily it doesn't hinder migration
since it is not a new bug (debbugs shows the version in testing as
already affected).

[...]
>                        (Doesn’t this make 676874 RC?)

I think so, yes.  Though it seems both will be fixed so soon that it
is hard for me to care much.

Thanks again and sorry for the fuss.
Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Thu, 14 Jun 2012 13:03:49 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 14 Jun 2012 13:03:56 GMT) Full text and rfc822 format available.

Message #69 received at 676874@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Jonathan Nieder <jrnieder@gmail.com>, 676970@bugs.debian.org
Cc: 676874@bugs.debian.org
Subject: Re: [Pkg-haskell-maintainers] Bug#676970: ghc fails to configure after install (update-alternatives priority out of range)
Date: Thu, 14 Jun 2012 14:14:43 +0200
[Message part 1 (text/plain, inline)]
Hi,

Am Donnerstag, den 14.06.2012, 06:29 -0500 schrieb Jonathan Nieder:
> Joachim Breitner wrote:
> 
> > An in case this bug now hinders the migration that mehdi set up for
> > today:
> 
> The severity does seem inflated.  Luckily it doesn't hinder migration
> since it is not a new bug (debbugs shows the version in testing as
> already affected).
> 
> [...]
> >                        (Doesn’t this make 676874 RC?)
> 
> I think so, yes.  Though it seems both will be fixed so soon that it
> is hard for me to care much.
> 
> Thanks again and sorry for the fuss.

thanks for the clarification and I’m glad that we do agree after all :-)

Greetings,
Joachim
-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Fri, 15 Jun 2012 09:15:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Fri, 15 Jun 2012 09:15:16 GMT) Full text and rfc822 format available.

Message #74 received at 676874@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: Joachim Breitner <nomeata@debian.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 676970@bugs.debian.org, 676874@bugs.debian.org, control@bugs.debian.org
Subject: Re: Bug#676970: ghc fails to configure after install (update-alternatives priority out of range)
Date: Fri, 15 Jun 2012 11:13:39 +0200
severity 676874 serious
thanks

On Thursday, 14. June 2012 14:14:43 Joachim Breitner wrote:
> Hi,
>
> Am Donnerstag, den 14.06.2012, 06:29 -0500 schrieb Jonathan Nieder:
> > Joachim Breitner wrote:
> > >                        (Doesn’t this make 676874 RC?)
> > I think so, yes.  Though it seems both will be fixed so soon that it
> > is hard for me to care much.

Raising the severity of #676874 to serious to prevent this version of dpkg 
migrating to testing, as it will make the whole ghc stack uninstallable (as 
seen in piuparts tests on sid). Feel free to downgrade it again, if a "fixed" 
version of ghc entered testing (but I hope for 1.16.4.3 being there first).

Once one of these bugs is fixed in sid I'll reschedule a full piuparts check 
of sid to look for more impact of this bug, so please drop me a notice how 
the new warning looks like.


Andreas




Severity set to 'serious' from 'important' Request was from Andreas Beckmann <debian@abeckmann.de> to control@bugs.debian.org. (Fri, 15 Jun 2012 09:15:34 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Sun, 17 Jun 2012 09:15:08 GMT) Full text and rfc822 format available.

Message sent on to Aleksandar Micovic <metaleks@gmail.com>:
Bug#676874. (Sun, 17 Jun 2012 09:15:11 GMT) Full text and rfc822 format available.

Message #81 received at 676874-submitter@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 676874-submitter@bugs.debian.org
Subject: Bug#676874 marked as pending
Date: Sun, 17 Jun 2012 09:13:02 +0000
tag 676874 pending
thanks

Hello,

Bug #676874 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=18d9373

---
commit 18d9373b27effd533d386fdf7bfde6e6b3782101
Author: Guillem Jover <guillem@debian.org>
Date:   Sun Jun 10 23:17:40 2012 +0200

    u-a: Only warn for now on out of range priorities on --install
    
    There seems to be packages using priorities > INT_MAX, which although
    bogus as they were previously overflowing the int used to store them,
    that would cause installation failures when upgrading from squeeze.
    
    Turn this into a warning for now and clamp the values, which will be
    switched back to an error after wheezy, in dpkg 1.17.x.
    
    Closes: #676874

diff --git a/debian/changelog b/debian/changelog
index b4f15bd..f7f9686 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,14 @@
+dpkg (1.16.4.3) UNRELEASED; urgency=low
+
+  * On «update-alternatives --install» only warn for now on out of range
+    priorities and clamp the values, as there seems to be packages using
+    priorities > INT_MAX, which although bogus as they were previously
+    overflowing the int used to store them, that would cause installation
+    failures when upgrading from squeeze. This will be reverted to an
+    error after wheezy. Closes: #676874
+
+ -- Guillem Jover <guillem@debian.org>  Sun, 10 Jun 2012 23:17:40 +0200
+
 dpkg (1.16.4.2) unstable; urgency=low
 
   * Check correctly for out of range negative field width values in dpkg-query




Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Sun, 17 Jun 2012 09:36:35 GMT) Full text and rfc822 format available.

Notification sent to Aleksandar Micovic <metaleks@gmail.com>:
Bug acknowledged by developer. (Sun, 17 Jun 2012 09:36:50 GMT) Full text and rfc822 format available.

Message #86 received at 676874-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 676874-close@bugs.debian.org
Subject: Bug#676874: fixed in dpkg 1.16.4.3
Date: Sun, 17 Jun 2012 09:33:41 +0000
Source: dpkg
Source-Version: 1.16.4.3

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.16.4.3_all.deb
  to main/d/dpkg/dpkg-dev_1.16.4.3_all.deb
dpkg_1.16.4.3.dsc
  to main/d/dpkg/dpkg_1.16.4.3.dsc
dpkg_1.16.4.3.tar.bz2
  to main/d/dpkg/dpkg_1.16.4.3.tar.bz2
dpkg_1.16.4.3_amd64.deb
  to main/d/dpkg/dpkg_1.16.4.3_amd64.deb
dselect_1.16.4.3_amd64.deb
  to main/d/dpkg/dselect_1.16.4.3_amd64.deb
libdpkg-dev_1.16.4.3_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.16.4.3_amd64.deb
libdpkg-perl_1.16.4.3_all.deb
  to main/d/dpkg/libdpkg-perl_1.16.4.3_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 676874@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 17 Jun 2012 10:56:15 +0200
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.16.4.3
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 676874
Changes: 
 dpkg (1.16.4.3) unstable; urgency=low
 .
   * On «update-alternatives --install» only warn for now on out of range
     priorities and clamp the values, as there seems to be packages using
     priorities > INT_MAX, which although bogus as they were previously
     overflowing the int used to store them, that would cause installation
     failures when upgrading from squeeze. This will be reverted to an
     error after wheezy. Closes: #676874
Checksums-Sha1: 
 68553fb7883e2cfd793fc82d973baefe67529b2b 1383 dpkg_1.16.4.3.dsc
 192971b080a3ab631630a39dc8fdcbb51efd48d8 5617310 dpkg_1.16.4.3.tar.bz2
 8d8243df75a477104721e8b906a848caf83aef6a 655816 libdpkg-dev_1.16.4.3_amd64.deb
 8b42f61e002c8764d679e480a1559bb22991f72d 2366940 dpkg_1.16.4.3_amd64.deb
 2e5076ef22d8be6c4df19a8460d31953aa78a385 1092042 dselect_1.16.4.3_amd64.deb
 6176c5eabef6d4380b2bfc9db37d301a453fe0a4 1139556 dpkg-dev_1.16.4.3_all.deb
 3fd8974af1f16988587d588419a9a231a749703d 853510 libdpkg-perl_1.16.4.3_all.deb
Checksums-Sha256: 
 1948ba1fc4086a02e5ae65ab749fe31bd4ac3264781f973675d93169814da69a 1383 dpkg_1.16.4.3.dsc
 065d14538eac820f980f52670053124616996d505be2402a8dd3aba9ab38855e 5617310 dpkg_1.16.4.3.tar.bz2
 1cf0edc2acba28ef2510f38ac40c61bf533269b0968d93fbf3a4554a95d63e30 655816 libdpkg-dev_1.16.4.3_amd64.deb
 bd0385d106fdc34fdc60a55eb7d5ea2a2745a3182ead1356dfb03f923ce967e7 2366940 dpkg_1.16.4.3_amd64.deb
 0ed32bbfe396d1daa00d9ba229d7015cf06565cd9ad55bd2a6e3dd664d725120 1092042 dselect_1.16.4.3_amd64.deb
 b99bb10185ecb9204cb333680def0f0fa12b4f3962873dd90fd198f6cc52a23e 1139556 dpkg-dev_1.16.4.3_all.deb
 a62a442aaec3c2b1aac35ba073b3248a971dba998cc742db9df8efc5fd57ac6a 853510 libdpkg-perl_1.16.4.3_all.deb
Files: 
 8ceb364935b1bed7e9b358a1f385d926 1383 admin required dpkg_1.16.4.3.dsc
 39c74a948c6fe4c02ed9f15556fe179d 5617310 admin required dpkg_1.16.4.3.tar.bz2
 5cff63d7cee10dc20ed1d7eac6be1d29 655816 libdevel optional libdpkg-dev_1.16.4.3_amd64.deb
 19e8700d0da64c87804b6205d0541290 2366940 admin required dpkg_1.16.4.3_amd64.deb
 687e3e38e0ac5242d2f0b074d7655dd1 1092042 admin optional dselect_1.16.4.3_amd64.deb
 c1f1a66a66508f9a155c4843a2eea2de 1139556 utils optional dpkg-dev_1.16.4.3_all.deb
 12c7cd4be6e64fe9e91a1e2591bdd91a 853510 perl optional libdpkg-perl_1.16.4.3_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAk/dnl4ACgkQuW9ciZ2SjJsdAQCaA0Q2medlf4nTUBHeOBE0kSQg
z6wAnjsT/plWqI1tSWzk9gGhY1iuJSfF
=JcQQ
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Sun, 24 Jun 2012 13:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 24 Jun 2012 13:54:03 GMT) Full text and rfc822 format available.

Message #91 received at 676874@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
Cc: 676874@bugs.debian.org
Subject: Re: Bug#676970: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 24 Jun 2012 15:49:57 +0200
On 2012-06-15 11:13, Andreas Beckmann wrote:
> Once one of these bugs is fixed in sid I'll reschedule a full piuparts check 
> of sid to look for more impact of this bug, so please drop me a notice how 
> the new warning looks like.

After I rechecked sid/amd64 with piuparts and dpkg 1.16.4.* I didn't
find any further occurrence of this error/warning.

Andreas




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Sun, 24 Jun 2012 17:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Sun, 24 Jun 2012 17:06:03 GMT) Full text and rfc822 format available.

Message #96 received at 676874@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Andreas Beckmann <debian@abeckmann.de>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 676970@bugs.debian.org, 676874@bugs.debian.org
Subject: Re: Bug#676970: ghc fails to configure after install (update-alternatives priority out of range)
Date: Sun, 24 Jun 2012 19:04:01 +0200
[Message part 1 (text/plain, inline)]
Hi Andreas,

Am Freitag, den 15.06.2012, 11:13 +0200 schrieb Andreas Beckmann:
> severity 676874 serious
> thanks
> 
> On Thursday, 14. June 2012 14:14:43 Joachim Breitner wrote:
> > Hi,
> >
> > Am Donnerstag, den 14.06.2012, 06:29 -0500 schrieb Jonathan Nieder:
> > > Joachim Breitner wrote:
> > > >                        (Doesn’t this make 676874 RC?)
> > > I think so, yes.  Though it seems both will be fixed so soon that it
> > > is hard for me to care much.
> 
> Raising the severity of #676874 to serious to prevent this version of dpkg 
> migrating to testing, as it will make the whole ghc stack uninstallable (as 
> seen in piuparts tests on sid). Feel free to downgrade it again, if a "fixed" 
> version of ghc entered testing (but I hope for 1.16.4.3 being there first).
> 
> Once one of these bugs is fixed in sid I'll reschedule a full piuparts check 
> of sid to look for more impact of this bug, so please drop me a notice how 
> the new warning looks like.

looks like ghc made it in first (with a hint by luk, so no fair
comparison). I’m not sure if #676874 can be downgraded, though, as it
would still break installing packages from squeeze.

Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#676874; Package dpkg. (Mon, 25 Jun 2012 08:06:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <debian@abeckmann.de>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 25 Jun 2012 08:06:10 GMT) Full text and rfc822 format available.

Message #101 received at 676874@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <debian@abeckmann.de>
To: Joachim Breitner <nomeata@debian.org>
Cc: Jonathan Nieder <jrnieder@gmail.com>, 676970@bugs.debian.org, 676874@bugs.debian.org
Subject: Re: Bug#676970: ghc fails to configure after install (update-alternatives priority out of range)
Date: Mon, 25 Jun 2012 10:03:04 +0200
On 2012-06-24 19:04, Joachim Breitner wrote:
> looks like ghc made it in first (with a hint by luk, so no fair
> comparison). I’m not sure if #676874 can be downgraded, though, as it
> would still break installing packages from squeeze.

Downgrading wouldn't help anything anyway as the fixed dpkg is already
sitting in unstable, waiting 3 more days for migration.


Andreas




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 25 Jul 2012 07:35:01 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:33:02 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.